<script setup lang="ts">
import DatePickerDialog from '@/components/DatePickerDialog.vue'
import { useDatePickerStore } from '@/services/datePicker'
import { usePromotionStore } from '@/stores/promotion'
import { ref } from 'vue'

const promotionStore = usePromotionStore()
const dateStore = useDatePickerStore()

const datePickerDialog = ref(false)
function getSelectedDate(startDate: string, endDate: string) {
  promotionStore.promotionItem.startDate = startDate
  promotionStore.promotionItem.endDate = endDate
  // if (dateStore.getSelectedDate == promotionStore.promotionItem.startDate){
  //   promotionStore.promotionItem.startDate = startDate
  // }else
  //   promotionStore.promotionItem.endDate = endDate
}

function openDatePickerDialog() {
  datePickerDialog.value = true
}

</script>

<template>
  <v-dialog v-model:model-value="promotionStore.dialog">
    <v-card class="pa-5" title="New Promotion">
      <!-- <v-form>
                {{ promotionStore.promotionItem }}
                <v-text-field v-for="(value, key) in promotionStore.promotionItem" :key="key" :label="key"
                    v-model="promotionStore.promotionItem[key]">
                </v-text-field>
            </v-form> -->

      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="12">
              <v-text-field v-model="promotionStore.promotionItem.name" label="Name">
              </v-text-field>
            </v-col>
            <v-col cols="12">
              <v-text-field v-model="promotionStore.promotionItem.description" label="Description">
              </v-text-field>
            </v-col>
            <v-col cols="12">
              <v-text-field v-model="promotionStore.promotionItem.discount" label="Discount">
              </v-text-field>
            </v-col>
            <v-col cols="6">
              <v-menu max-width="290">
                <template #activator>
                  <v-text-field
                    v-model="promotionStore.promotionItem.startDate"
                    readonly
                    prepend-icon="mdi-calendar"
                    @click="openDatePickerDialog"
                    label="Start Date"
                  >
                  </v-text-field>
                  <date-picker-dialog
                    :dialog="datePickerDialog"
                    @getDialog="(newValue) => (datePickerDialog = newValue)"
                    @selectedDate="getSelectedDate"
                  />
                </template>
              </v-menu>
            </v-col>
            <v-col cols="6">
              <v-menu max-width="290">
                <template #activator>
                  <v-text-field
                    v-model="promotionStore.promotionItem.endDate"
                    readonly
                    prepend-icon="mdi-calendar"
                    @click="openDatePickerDialog"
                    label="End Date"
                  >
                  </v-text-field>
                  <date-picker-dialog
                    :dialog="datePickerDialog"
                    @getDialog="(newValue) => (datePickerDialog = newValue)"
                    @selectedDate="getSelectedDate"
                  />
                </template>
              </v-menu>
            </v-col>
            <v-col cols="12">
              <label for="Status">Status</label>
              <v-select
                v-model="promotionStore.promotionItem.status"
                :items="[
                  { title: 'Active', value: 'active' },
                  { title: 'Inactive', value: 'inactive' }
                ]"
                label="status"
                :return-object="false"
              ></v-select>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>

      <template #actions>
        <v-row justify="end">
          <v-btn @click="promotionStore.closeDialog()"> Cancel </v-btn>
          <v-btn @click="promotionStore.save()"> Save </v-btn>
        </v-row>
      </template>
    </v-card>
  </v-dialog>
</template>

<style scoped></style>
